import {writable} from "svelte/store";
import type { Image } from "image-js";
export type BGColor ="transparent" | "blue" | "green" | "pink" | {custom: string} ;


 export  type Meta = {
    threshold: string | null;
    closeThreshold: string | null;
  };

export  class WebRay {
    meta: Meta;
    frames: Array<string | null>;
    public constructor(
      frames: Array<string | null> = [null, null, null, null],
      meta: Meta = { threshold: null, closeThreshold: null }
    ) {
      this.frames = frames;
      this.meta = meta;
    }
}

export class Config {
  background_color: BGColor;
  blink_interval: number;
  mic_sens: number;


  constructor(){
    this.background_color = "transparent";
    this.blink_interval = 1500;
    this.mic_sens = 1.0;
  }
}



export let frames = writable<Array<Image |  null>>([null, null, null, null]);
export let config = writable(new Config());
